SystemOrganization addCategory: #'Pier-EditorEnh'!

WAFileLibrary subclass: #PREditorScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-EditorEnh'!

!PREditorScripts methodsFor: 'accessing' stamp: 'lr 6/24/2007 16:37'!
selectorsToInclude
	^ #( toolbarCss toolbarJs )! !

!PREditorScripts methodsFor: 'accessing-files' stamp: 'lr 3/12/2009 18:23'!
toolbarCss
	^ '/*	Silk Icons 1.3 (http://www.famfamfam.com/lab/icons/silk/)
	Creative Commons Attribution 2.5 License
	Mark James */
	
td.wiki textarea {
	outline: 0;
	margin: 0;
	padding: 0;
	clear: both;
	width: 100%;
	height: 250px;
	font-size: 10px;
	font-family: Monaco, Courier, monospace;
}
	
td.wiki .toolbar,
td.wiki .toolbar * {
	border: 0;
	outline: 0;
	margin: 0;
	padding: 0;
	background-color: inherit;
}
td.wiki .toolbar {
	width: 100%;
}

td.wiki .toolbar hr {
	float: left;
	width: 1px;
	clear: none;
	height: 16px;
	margin: 4px;
	display: block;
	background-color: #ccc;
}
td.wiki .toolbar a {
	float: left;
	width: 16px;
	height: 16px;
	padding: 4px;
	display: block;
}
td.wiki .toolbar a:hover { background-color: #eee; }
td.wiki .toolbar a:active { background-color: #ccc; }

td.wiki .toolbar a span {
	width: 16px;
	height: 16px;
	display: block;
	background-color: inherit;
	background-repeat: no-repeat;
	background-image: url(toolbar.png);
}

td.wiki .toolbar a.bold span { background-position: 0px 0px; }
td.wiki .toolbar a.italic span { background-position: -16px 0px; }
td.wiki .toolbar a.underline span { background-position: -32px 0px; }
td.wiki .toolbar a.strikethrough span { background-position: -48px 0px; }
td.wiki .toolbar a.monospace span { background-position: -64px 0px; }
td.wiki .toolbar a.subscript span { background-position: -80px 0px; }
td.wiki .toolbar a.superscript span { background-position: -96px 0px; }

td.wiki .toolbar a.link span { background-position: -128px 0px; }
td.wiki .toolbar a.embed span { background-position: -144px 0px; }

td.wiki .toolbar a.anchor span { background-position: -176px 0px; }
td.wiki .toolbar a.header span { background-position: -192px 0px; }
td.wiki .toolbar a.ruler span { background-position: -208px 0px; }
td.wiki .toolbar a.ordered span { background-position: -224px 0px; }
td.wiki .toolbar a.unordered span { background-position: -240px 0px; }
td.wiki .toolbar a.term span { background-position: -256px 0px; }
td.wiki .toolbar a.data span { background-position: -272px 0px; }
td.wiki .toolbar a.table span { background-position: -288px 0px; }
td.wiki .toolbar a.preformatted span { background-position: -304px 0px; }'! !

!PREditorScripts methodsFor: 'accessing-files' stamp: 'lr 3/12/2009 18:03'!
toolbarJs
	^ 'function EditorEnh(textarea, options) {
	var self = this;
	self.textarea = textarea;
	
	// public
	self.addButton = function(css, tooltip, method) {
		var args = new Array();
		for (var index = 3; index < arguments.length; index++)
			args[index - 3] = arguments[index];
		var button = document.createElement("a");
		button.className = css;
		button.title = tooltip;
		button.addEventListener("click", function(event) {
			self[method].apply(self, args);
			return false;
		}, false);
		button.appendChild(document.createElement("span"));
		self.toolbar.appendChild(button);
	};
	self.addSeparator = function() {
		var separator = document.createElement("hr");
		self.toolbar.appendChild(separator);
	};
	
	// actions
	self.replaceText = function(text) {
		var value = self.textarea.value;
		var selection = self.getSelection(self.textarea);
		self.textarea.value = value.substring(0, selection[0]) + text + value.substring(selection[1], value.length);
		self.setSelection(self.textarea, [selection[0] + text.length, selection[0] + text.length]);
	};
	self.insertText = function(open, close, sample) {
		var value = self.textarea.value;
		var selection = self.getSelection(self.textarea);
		var selected = value.substring(selection[0], selection[1]) || sample;
		self.textarea.value = value.substring(0, selection[0]) + open + selected +
			close + value.substring(selection[1], value.length);
		self.setSelection(self.textarea, [selection[0] + open.length, selection[0] + open.length + selected.length]);
	};
	self.insertLine = function(open, sample) {
		var value = self.textarea.value;
		var selection = self.getSelection(self.textarea);
		var start = value.lastIndexOf("\n", selection[0]);
		if (start < 0) start = 0;
		var end = value.indexOf("\n", selection[1]);
		if (end < 0) end = value.length - 1;
		var selected = value.substring(start, end) || (open + sample);
		selected = selected.replace(/\n/g, "\n" + open);
		if (start == 0) selected = open + selected;
		self.textarea.value = value.substring(0, start) + selected +
			value.substring(end, value.length);
		self.setSelection(self.textarea, [start + open.length, start + open.length + selected.length - 1]);
	};
	
	// private
	self.onKeyDown = function(event) {
		if (!!event.shiftKey && !!event.ctrlKey && !!event.altKey && !!event.metaKey) {
			if (event.which == 9 || event.keyCode == 9) {
				self.replaceText("\t");
				setTimeout(function() { self.textarea.focus(); }, 1);
				event.stopPropagation();
				return false;
			}
		}
		return true;
	};
	self.getSelection = function(element) {
		if (document.selection && document.selection.createRange) {
			var range = document.selection.createRange();
			var stored = range.duplicate();
			stored.moveToElementText(element);
			stored.setEndPoint("EndToEnd", range);
			element.selectionStart = stored.text.length - range.text.length;
			element.selectionEnd = element.selectionStart + range.text.length;
		}
		return [element.selectionStart, element.selectionEnd];
	};
	self.setSelection = function(element, range) {
		element.focus();
		element.selectionStart = range[0];
		element.selectionEnd = range[1];
		if (document.selection && document.selection.createRange) {
			var range = document.selection.createRange();
	 		range.moveStart("character", element.selectionStart);
	    		range.moveEnd("character", element.selectionEnd - element.selectionStart);
			range.select();
		}
	};
	
	// constructor
	if (options.binding) 
		self.textarea.addEventListener("keydown", self.onKeyDown, false);
	if (options.toolbar) {
		self.toolbar = document.createElement("div");
		self.toolbar.className = "toolbar";
		self.addButton("bold", "Bold Text", "insertText", ''""'', ''""'', "Bold Text");
		self.addButton("italic", "Italic Text", "insertText", "''''", "''''", "Italic Text");
		self.addButton("underline", "Underlined Text", "insertText", "__", "__", "Underlined Text");
		self.addButton("strikethrough", "Striked Text", "insertText", "--", "--", "Striked Text");
		self.addButton("monospace", "Monospace Text", "insertText", "==", "==", "Monospace text");
		self.addButton("subscript", "Subscript Text", "insertText", "@@", "@@", "Subscript Text");
		self.addButton("superscript", "Superscript Text", "insertText", "^^", "^^", "Superscript Text");
		self.addSeparator();
		self.addButton("link", "Link", "insertText", "*", "*", "Alias>Path@Anchor");
		self.addButton("embed", "Embed", "insertText", "+", "+", "Alias>Path@Anchor");
		self.addSeparator();
		self.addButton("anchor", "Anchor", "insertLine", "@", "Anchor");
		self.addButton("header", "Header", "insertLine", "!!", "Header");
		self.addButton("ruler", "Horizontal Ruler", "insertLine", "_", "");
		self.addButton("ordered", "Ordered List", "insertLine", "#", "Ordered List");
		self.addButton("unordered", "Unordered List", "insertLine", "-", "Unordered List");
		self.addButton("term", "Definition Term", "insertLine", ";", "Definition Term");
		self.addButton("data", "Definition Data", "insertLine", ":", "Definition Data");
		self.addButton("table", "Table", "insertLine", "|", "Table");
		self.addButton("preformatted", "Preformatted", "insertLine", "=", "Preformatted");
		self.textarea.parentNode.insertBefore(self.toolbar, self.textarea);
	}
};

// install editors
window.addEventListener("load", function(event) {
	var textareas = document.getElementsByTagName("textarea");
	for (var index = 0; index < textareas.length; index++) {
		var textarea = textareas[index];
		new EditorEnh(textarea, { 
			binding: true, 
			toolbar: textarea.parentNode.tagName == "TD" && textarea.parentNode.className.indexOf("wiki") >= 0
		});
	}
}, false);'! !

!PREditorScripts methodsFor: 'accessing-files' stamp: 'lr 3/12/2009 17:46'!
toolbarPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 1 64 0 0 0 16 8 6 0 0 0 103 105 166 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 19 147 73 68 65 84 120 218 236 156 13 92 84 85 222 199 207 12 243 134 131 204 12 190 33 162 188 8 41 138 134 233 162 169 173 84 202 67 185 187 178 102 89 235 27 148 89 173 79 58 106 166 110 62 66 106 37 90 8 173 90 105 159 196 208 245 227 102 138 89 61 126 84 20 75 13 51 12 21 35 145 16 1 81 94 100 120 127 153 153 59 247 249 253 47 51 48 78 188 204 8 180 238 179 156 207 231 120 238 189 115 255 231 158 115 238 57 223 243 251 159 115 81 196 243 60 235 14 221 161 59 116 135 127 231 16 241 121 126 48 146 56 95 181 226 225 90 131 137 81 52 152 76 172 206 104 170 192 245 42 196 82 68 14 81 135 120 7 49 17 241 168 164 187 233 186 195 255 199 112 225 194 133 88 163 209 24 105 48 24 24 210 157 147 38 77 90 122 63 151 247 213 132 2 191 96 63 229 181 57 19 53 162 255 180 119 181 251 219 242 53 208 97 47 114 188 201 211 4 104 113 38 198 140 148 114 116 204 51 35 210 230 200 49 206 200 227 186 233 252 91 179 253 131 45 121 152 140 198 177 15 186 187 60 188 108 82 159 187 242 174 209 155 84 181 136 186 122 206 83 111 0 9 27 56 150 91 90 205 254 247 151 154 41 248 89 123 95 1 48 54 54 54 2 201 102 68 53 26 34 238 181 215 94 91 98 249 109 213 170 85 7 245 122 125 120 125 125 253 146 173 91 183 198 253 167 117 146 167 183 222 240 246 233 43 79 82 57 139 189 207 101 86 199 125 177 220 55 186 27 115 173 7 128 143 224 23 5 248 209 241 155 184 212 165 0 92 185 114 101 147 43 197 97 144 162 175 50 244 85 86 91 91 43 196 154 154 26 33 86 87 87 11 105 86 86 214 93 160 35 248 117 16 160 218 128 1 10 109 230 205 250 184 191 71 120 254 91 141 15 19 207 191 250 84 112 207 222 142 216 68 239 203 30 121 87 30 70 99 63 87 89 99 147 230 151 115 76 42 18 49 9 78 157 64 56 185 84 204 6 201 197 204 73 44 102 82 39 198 70 121 58 51 15 149 210 109 199 247 133 239 73 90 0 208 98 188 192 32 116 156 114 196 184 134 134 134 32 116 160 16 164 73 72 9 62 229 246 22 114 237 218 181 209 176 209 162 51 168 16 43 144 71 250 182 109 219 66 90 187 127 233 210 165 9 40 195 60 60 63 100 249 242 229 75 172 127 171 171 171 139 68 30 222 176 111 247 229 110 218 180 73 131 178 111 64 76 131 141 6 101 240 197 179 125 55 111 222 60 165 11 7 64 10 13 54 234 248 120 22 197 8 12 128 4 148 155 202 206 142 30 61 26 210 145 252 85 61 156 226 126 206 173 13 231 140 92 68 112 64 207 40 234 3 221 152 107 19 128 20 43 205 105 151 63 111 195 134 13 29 82 110 164 252 18 79 235 120 171 254 180 16 201 22 130 169 25 226 66 223 162 148 250 23 29 239 223 191 191 233 153 4 63 239 62 50 47 82 53 228 10 58 106 191 98 197 10 158 212 23 221 107 137 150 182 179 182 165 148 98 114 114 242 93 245 237 136 61 212 156 0 191 67 57 187 160 252 96 203 193 22 169 129 51 52 167 184 102 249 109 229 195 111 33 47 78 110 253 124 206 96 112 85 74 72 57 66 229 233 69 128 29 224 135 214 148 24 145 2 122 98 122 26 207 177 1 42 39 182 106 79 30 139 153 229 197 190 203 145 246 145 216 2 104 227 198 141 94 24 176 65 34 145 40 125 205 154 53 52 115 178 197 139 23 239 68 133 34 48 147 5 225 116 148 189 47 21 246 209 175 191 254 122 4 42 174 66 158 218 15 63 252 48 161 61 27 75 195 217 134 184 184 184 242 200 200 72 187 224 139 6 254 5 249 196 68 69 69 109 55 151 127 5 94 250 130 54 148 103 138 249 48 29 145 224 159 139 60 212 136 161 176 43 70 217 147 168 77 80 255 114 164 229 85 85 85 33 56 214 158 57 115 38 201 170 220 113 184 159 128 167 66 249 227 19 18 18 114 167 77 155 150 130 115 111 196 14 195 234 227 72 207 112 74 159 223 145 23 94 160 51 220 232 236 1 12 23 81 25 24 24 248 215 1 3 6 172 234 223 191 191 38 39 39 39 175 188 188 252 25 252 116 67 173 86 159 241 69 184 117 235 150 238 230 205 155 239 100 100 100 108 59 117 234 84 141 181 253 83 79 61 165 28 57 114 228 95 61 60 60 86 245 237 219 87 115 227 198 141 188 138 138 138 38 123 47 47 47 223 219 183 111 235 144 199 59 151 47 95 222 134 193 87 211 149 64 194 187 192 107 48 124 98 30 128 165 93 13 64 76 216 124 123 170 207 114 221 124 207 93 0 177 192 47 241 27 29 63 231 247 26 17 128 186 21 167 91 237 125 62 41 63 130 159 57 101 142 218 199 196 196 116 8 224 29 177 39 55 151 194 95 134 189 96 215 253 53 245 96 132 145 99 54 0 116 235 41 19 179 154 6 250 157 99 98 16 143 224 38 192 15 209 137 1 138 40 33 248 200 68 92 37 75 205 209 177 11 121 21 133 146 150 102 78 130 16 209 220 74 125 229 210 102 137 25 128 118 135 101 203 150 145 122 244 2 68 42 62 250 232 163 4 59 59 110 171 51 54 117 158 246 194 250 245 235 23 144 234 195 204 167 177 92 139 143 143 143 153 59 119 238 228 54 204 212 168 95 4 160 175 70 89 23 163 238 41 171 87 175 142 198 172 86 130 206 250 229 251 239 191 175 157 53 107 22 193 76 125 224 192 129 240 9 19 38 68 3 130 212 22 77 0 124 247 221 119 147 94 122 233 165 112 148 253 36 158 191 24 240 203 197 253 33 246 42 63 123 20 100 200 170 204 232 126 30 10 118 35 171 58 156 69 14 236 180 193 59 122 244 104 25 192 21 53 100 200 144 229 51 103 206 20 6 235 224 193 131 7 165 164 164 236 69 121 10 230 204 153 51 64 34 145 48 192 75 147 150 150 182 49 47 47 175 15 108 86 227 88 79 246 161 161 161 178 129 3 7 70 249 251 251 47 15 11 11 19 202 59 8 33 53 53 117 47 218 163 0 109 49 192 9 61 177 180 180 84 115 229 202 21 193 30 54 171 81 39 125 103 131 232 155 111 190 57 143 103 142 162 62 4 240 138 24 198 86 238 141 92 183 196 196 68 35 234 242 227 11 47 188 240 187 150 236 22 45 90 244 38 250 192 112 244 1 114 97 63 131 167 179 15 19 238 76 228 243 52 1 11 239 227 202 225 195 135 163 30 121 228 145 48 212 239 191 126 248 225 135 37 54 94 71 135 21 96 71 236 205 110 239 61 187 190 49 95 150 101 172 248 131 91 96 83 121 230 204 201 180 86 108 182 17 245 15 176 205 227 173 67 101 25 111 76 107 204 195 17 123 90 235 163 176 247 116 177 93 101 253 211 24 55 166 183 5 160 94 223 79 229 236 196 42 234 140 172 182 129 7 0 121 65 5 138 57 179 26 68 71 32 24 50 222 137 21 85 54 176 248 99 217 149 56 139 248 21 0 205 131 79 88 199 160 48 127 254 124 53 58 64 132 25 64 9 142 52 42 217 17 72 49 160 146 28 113 93 168 129 238 21 128 176 205 49 67 116 197 194 133 11 53 168 203 246 143 63 254 56 13 157 54 166 173 37 5 192 58 29 234 55 196 50 1 152 203 255 6 236 142 90 158 77 51 57 5 40 191 104 63 63 191 112 219 76 0 249 148 103 159 125 54 158 0 8 219 205 176 213 216 91 239 246 20 228 196 101 87 194 229 206 98 239 156 159 42 67 224 17 4 61 24 113 193 251 98 194 67 185 157 1 13 12 252 48 192 111 193 228 201 147 117 90 173 54 21 112 15 5 16 157 70 140 24 225 3 232 249 0 238 172 176 176 144 235 217 179 231 209 240 240 240 225 116 47 148 224 105 152 126 97 109 63 126 252 120 221 218 181 107 83 43 43 43 67 161 36 157 2 2 2 124 138 138 138 124 118 236 216 193 112 191 96 63 117 234 84 193 30 10 177 201 190 147 93 223 195 136 13 212 7 160 96 39 112 70 97 61 46 213 220 39 142 182 102 135 73 46 10 16 44 196 123 56 187 109 219 182 125 116 109 231 206 157 251 158 70 64 31 26 15 248 205 0 252 198 227 93 204 199 187 29 143 159 239 2 32 6 60 223 134 234 227 96 115 14 233 132 214 158 255 73 74 25 79 32 56 113 165 202 127 239 34 159 236 223 122 201 160 222 192 177 87 62 45 184 146 117 173 102 70 242 186 33 153 104 47 159 214 224 101 59 62 195 99 175 7 120 187 203 247 187 200 36 188 213 56 180 219 222 200 53 139 173 231 38 246 101 255 60 83 196 158 153 208 175 233 218 231 169 69 236 169 113 205 231 165 149 245 191 82 128 152 221 188 250 185 74 89 69 61 207 132 209 139 146 56 1 126 98 42 17 215 8 64 9 47 102 36 54 57 41 135 251 141 62 135 150 76 40 147 180 166 192 104 189 13 179 101 20 94 126 56 32 230 141 206 148 242 245 215 95 71 58 8 192 112 2 41 94 124 146 3 54 173 2 144 58 148 29 235 142 199 49 136 143 163 35 79 198 179 23 160 46 11 166 79 159 158 134 122 172 108 99 237 49 201 82 119 130 191 5 128 80 142 219 173 159 109 13 224 236 236 236 22 235 68 176 66 29 72 69 210 253 209 230 53 153 118 67 123 10 242 15 111 103 37 120 186 43 38 25 189 122 204 171 170 227 42 246 45 242 85 119 86 231 135 234 153 168 82 169 228 39 78 156 208 226 153 137 24 188 69 0 185 139 70 163 17 6 114 73 73 9 59 166 219 36 230 156 10 159 192 241 203 184 55 142 108 44 0 163 99 87 87 87 57 20 159 22 117 78 4 0 139 94 121 229 21 23 220 39 180 89 89 89 25 251 224 131 15 234 160 34 103 220 185 115 103 14 238 141 19 139 197 19 187 2 128 143 63 254 248 90 234 6 130 162 216 187 87 112 75 231 205 155 55 209 206 73 168 233 221 91 247 71 234 19 20 190 253 246 219 179 129 129 129 15 163 78 227 109 109 161 48 59 164 224 158 15 113 19 61 19 123 221 111 220 16 97 51 196 225 188 94 220 158 175 245 239 47 215 158 207 170 142 251 108 153 175 67 74 112 253 225 219 124 63 149 140 57 203 164 172 84 39 253 52 120 225 165 185 223 239 219 167 176 75 141 109 204 9 232 223 87 250 169 119 47 201 48 177 200 137 45 251 71 1 255 222 95 60 69 251 236 180 23 38 45 0 208 4 15 83 2 133 246 249 119 197 80 106 98 118 32 181 152 137 72 193 153 239 57 244 125 49 205 180 76 42 161 245 206 30 76 111 176 85 128 13 94 238 42 57 203 44 226 204 118 141 240 19 55 178 176 177 159 243 66 22 204 72 2 207 76 80 73 11 3 88 0 32 185 189 152 1 105 13 240 77 184 53 59 165 82 105 196 216 177 99 127 196 245 71 47 93 186 212 238 90 28 220 135 32 116 62 90 79 172 128 219 104 55 0 169 179 81 167 115 4 128 177 177 177 203 145 108 180 156 195 251 18 82 168 15 86 92 92 204 46 94 188 56 58 39 39 231 24 185 55 214 203 54 80 46 239 218 62 155 234 222 210 243 9 4 22 5 216 86 48 175 23 46 65 222 155 1 193 197 62 62 62 73 215 175 95 79 177 103 23 183 45 5 249 229 223 30 8 97 93 20 80 231 235 80 104 245 189 123 247 238 9 87 245 32 224 36 143 137 137 97 74 165 178 169 221 61 166 235 69 62 253 2 216 233 134 173 31 170 111 78 42 39 27 171 118 187 14 133 88 223 171 87 47 193 30 81 14 69 213 100 79 237 70 121 154 127 59 6 85 89 143 58 94 239 106 85 99 121 159 14 168 112 186 127 224 236 217 179 151 89 192 135 56 144 198 132 181 23 98 125 78 225 157 67 197 201 158 189 164 143 181 184 190 197 241 194 39 29 6 164 84 20 3 4 65 3 24 155 145 95 123 226 31 175 250 62 222 180 134 186 233 23 191 177 67 149 215 150 78 237 43 116 82 64 123 33 218 104 139 197 35 179 68 171 114 177 171 87 175 54 117 104 223 190 82 173 167 155 196 171 180 191 66 216 4 113 196 126 245 31 221 69 255 157 120 59 163 88 87 39 206 249 169 106 110 218 71 15 102 62 241 196 19 25 22 181 102 217 52 177 222 200 128 130 23 92 221 47 94 247 205 124 116 85 230 220 170 58 227 231 74 133 194 180 35 210 83 184 110 175 189 197 5 38 72 73 156 68 236 207 193 125 0 187 18 54 45 184 239 93 10 208 250 60 187 176 18 239 170 89 53 134 173 59 226 44 113 18 203 104 183 87 143 246 21 11 185 241 172 81 252 53 54 17 253 43 22 55 182 127 117 77 45 205 114 149 173 2 208 172 94 172 193 179 4 133 142 80 40 20 65 80 0 17 246 172 53 192 62 130 214 125 208 249 147 28 233 180 176 75 71 71 12 153 57 115 102 56 102 145 38 219 49 99 198 132 224 229 165 183 162 224 54 209 50 12 29 67 69 105 0 18 157 229 183 41 83 166 44 128 59 183 194 188 136 159 150 145 145 49 166 173 245 71 234 32 182 29 220 2 129 182 20 40 20 155 26 118 113 4 64 40 133 184 97 195 134 121 59 59 59 19 200 146 220 220 220 66 166 191 119 41 218 158 93 220 123 85 144 29 9 104 239 20 0 236 246 3 15 60 240 6 0 108 130 82 147 158 170 219 204 76 92 37 211 11 187 112 28 243 112 243 99 1 238 99 89 85 125 13 187 56 228 144 202 120 90 125 202 214 222 207 207 239 13 168 109 193 190 180 180 148 97 210 97 50 153 140 121 122 122 50 192 85 138 251 198 224 29 4 3 182 183 49 16 82 58 171 252 80 201 11 145 223 82 196 88 184 232 91 173 223 167 173 55 177 102 205 154 166 123 161 186 183 182 176 252 146 191 103 207 158 247 44 215 224 246 62 140 119 50 208 122 124 216 78 144 4 191 190 174 205 67 201 100 226 27 191 95 163 104 20 9 59 147 36 88 140 18 19 142 37 2 20 61 52 178 187 128 57 198 95 121 173 94 111 98 255 243 89 33 191 238 105 15 209 174 93 187 28 218 196 248 254 106 85 92 89 181 179 246 226 79 85 24 155 30 204 81 251 218 6 19 251 231 34 159 97 86 202 215 207 214 109 181 222 205 181 14 39 223 9 200 68 50 108 214 71 133 25 247 98 79 10 144 71 27 73 0 168 47 211 74 132 181 58 74 5 64 137 155 33 40 49 111 98 12 243 80 0 110 205 0 52 54 232 251 40 149 10 97 167 215 100 118 127 73 235 144 10 228 205 199 132 64 103 41 99 119 170 27 232 254 162 227 235 255 196 183 8 64 11 248 172 1 136 1 93 142 1 205 104 33 28 16 80 217 181 83 83 83 19 78 138 203 17 247 215 220 193 226 105 237 16 49 106 242 228 201 233 199 143 31 207 29 61 122 116 8 174 111 70 94 127 182 3 160 79 207 152 49 67 179 127 255 126 97 205 239 216 177 99 228 198 110 15 8 8 224 145 167 166 157 103 11 179 85 43 0 84 35 150 183 163 252 232 249 212 86 65 180 107 172 211 233 78 153 103 219 184 93 11 124 180 120 241 185 237 237 226 182 166 32 187 18 128 28 199 101 193 109 125 46 57 57 249 32 38 139 62 114 185 188 158 141 211 43 166 4 206 99 28 79 31 163 114 140 230 232 194 138 124 54 194 115 2 171 214 215 137 202 103 159 186 56 114 189 88 118 105 181 137 7 216 178 42 42 42 158 59 121 242 228 193 1 3 6 8 246 40 191 24 238 238 139 72 111 86 85 85 29 196 99 164 232 252 114 192 175 4 231 207 161 45 178 58 113 199 119 139 66 78 30 151 104 203 238 221 187 183 144 231 241 252 243 207 231 89 43 192 117 235 214 13 194 245 27 4 99 137 147 132 93 186 124 105 139 45 32 90 2 38 193 206 26 120 173 77 144 183 116 134 22 149 158 193 72 127 145 192 4 197 98 37 90 126 21 86 133 187 119 200 133 62 184 194 191 67 155 32 159 204 247 8 188 11 106 39 79 42 28 205 99 207 75 205 121 56 98 79 109 68 155 172 244 141 94 216 168 62 236 248 197 82 54 249 193 230 207 2 143 165 151 176 113 67 52 172 167 115 35 174 174 230 87 48 165 92 98 237 254 246 144 40 101 2 44 157 64 65 206 36 18 124 93 97 199 151 160 104 106 220 1 238 129 27 74 116 117 116 127 161 197 182 69 5 72 202 141 6 188 229 218 208 161 67 181 46 46 46 244 241 102 57 58 192 174 246 42 244 228 147 79 134 160 66 94 24 20 236 236 217 179 14 1 48 49 49 49 119 234 212 169 163 80 142 40 196 157 163 70 141 162 50 165 163 60 145 249 249 249 185 118 0 144 58 233 134 199 30 123 108 251 137 19 39 116 86 46 172 14 215 183 183 3 64 250 212 231 20 193 43 52 52 148 214 223 4 240 64 217 104 9 126 164 0 49 9 104 105 195 162 5 21 98 235 162 254 202 101 109 107 23 183 61 5 89 86 86 150 222 85 0 132 43 68 235 33 148 191 143 229 218 252 132 135 120 130 223 141 59 215 132 111 177 140 38 131 240 61 86 101 67 21 11 26 248 8 171 54 212 74 206 93 63 77 100 144 159 59 119 238 87 246 54 193 181 43 1 14 104 185 163 221 110 203 229 206 52 217 172 4 244 200 5 119 71 42 172 1 174 93 187 150 142 229 136 43 49 36 54 252 124 245 103 2 99 159 214 60 0 219 241 96 45 6 232 220 118 157 176 51 254 122 99 229 222 2 158 22 232 233 227 139 119 103 123 254 230 127 13 130 49 199 183 181 105 97 253 77 31 69 76 98 162 206 178 55 154 191 56 33 120 17 252 40 88 82 82 117 52 129 124 155 217 52 148 217 224 62 178 166 157 227 71 180 123 136 148 235 130 135 14 98 183 43 121 150 91 196 49 136 65 166 144 137 153 66 10 168 194 94 42 19 49 25 224 234 218 3 238 115 126 45 109 152 20 181 8 64 184 47 194 183 126 232 4 180 251 200 70 140 24 177 217 60 227 5 21 23 23 211 71 209 241 128 64 155 16 10 11 11 139 166 197 123 216 17 72 152 191 191 127 210 181 107 215 194 29 121 25 95 125 245 21 61 35 242 94 94 36 65 10 207 37 216 29 27 57 114 228 103 116 76 107 105 168 215 118 64 164 173 157 96 182 99 199 142 136 150 174 103 103 103 119 104 118 165 208 222 46 110 123 10 82 42 149 146 130 76 255 173 6 68 189 177 94 248 232 180 159 235 32 116 80 78 80 130 183 42 242 152 155 139 59 187 144 127 134 157 249 229 244 207 122 35 123 136 221 7 1 237 83 67 31 233 99 194 93 162 86 171 55 64 101 210 7 248 251 251 247 239 47 162 165 4 0 126 19 206 103 248 248 248 42 174 92 201 200 163 191 12 177 124 229 96 9 240 26 222 68 62 103 169 189 225 246 206 196 36 180 47 48 48 112 166 121 205 239 172 70 163 121 19 199 63 193 110 56 226 89 120 55 244 23 75 177 152 232 243 59 163 14 27 158 243 20 189 182 187 128 79 61 175 243 103 179 61 29 182 255 189 246 178 214 119 136 139 54 251 231 234 184 211 241 35 28 238 171 24 115 29 130 110 71 236 105 66 225 205 238 238 163 35 122 179 148 140 82 22 18 216 172 0 15 164 150 176 233 227 154 231 43 82 128 78 98 139 250 211 211 58 234 212 180 204 235 76 87 39 97 213 13 188 160 194 27 12 34 166 55 54 254 249 28 109 176 184 169 84 236 229 80 119 118 251 78 45 217 148 180 8 192 3 7 14 36 32 73 232 72 67 28 57 114 36 186 35 246 232 124 188 101 157 197 234 163 209 166 153 23 157 79 212 206 243 5 151 151 221 103 65 221 75 170 109 107 23 215 30 5 249 91 134 90 99 189 41 225 187 77 76 111 130 42 50 234 217 224 222 195 197 227 124 67 217 249 27 167 89 114 214 209 75 128 95 112 225 219 124 195 253 208 182 80 24 244 217 11 125 244 252 101 65 65 193 38 165 82 25 174 82 169 102 3 134 130 107 5 88 205 190 89 112 147 1 126 73 232 67 203 17 75 17 239 242 99 247 239 223 31 101 155 111 70 70 6 125 14 179 207 230 242 190 174 170 7 193 111 220 239 52 194 46 240 232 209 163 23 2 198 91 44 27 8 22 119 222 162 166 204 59 214 205 155 32 128 95 144 183 178 233 47 65 28 181 167 113 215 210 102 133 181 106 43 47 47 23 181 53 110 239 213 94 88 3 196 123 10 28 228 194 110 149 213 177 193 253 156 217 245 219 213 77 127 11 60 124 128 76 128 158 117 48 153 120 65 2 114 6 195 67 211 66 70 58 255 109 214 184 187 151 117 120 38 128 80 111 108 92 19 220 122 164 144 245 144 50 86 85 93 75 54 119 88 211 206 112 247 255 6 211 29 236 8 129 235 197 37 99 6 61 214 59 37 43 57 77 111 98 227 1 63 253 253 90 214 245 235 215 135 97 192 77 67 124 212 60 216 79 34 61 180 101 203 150 35 247 107 153 73 253 81 122 254 199 138 152 83 239 13 95 233 176 135 177 248 178 214 111 232 189 43 192 127 101 88 182 51 243 180 209 192 5 233 57 147 146 190 78 161 200 209 218 169 240 159 31 24 91 180 41 175 170 63 148 188 97 114 248 152 136 173 47 143 31 229 247 65 240 176 65 76 237 226 204 212 174 10 166 86 202 153 10 177 103 15 25 147 195 21 150 67 90 230 221 49 50 90 54 220 126 224 44 59 252 205 101 237 15 9 11 227 187 1 216 29 236 14 190 107 68 37 156 201 169 119 157 137 147 22 191 205 27 187 91 164 59 220 15 225 161 217 241 189 205 170 151 212 111 47 115 212 152 163 74 33 147 74 21 10 41 115 85 18 28 123 176 75 87 243 105 243 109 214 133 221 139 127 32 251 255 19 96 0 147 203 244 35 54 205 168 229 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!PRChangeCommand methodsFor: '*pier-editorenh' stamp: 'lr 11/5/2007 22:14'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	PREditorScripts default
		updateRoot: aHtmlRoot! !
